<?php

$d = dir("./");
while($entry=$d->read()) {
	if (preg_match("/^text\.(.*)\.tbl$/", $entry, $match))
		$tables[$match[1]] = $entry;
}
$d->close();

$tbl = "";
$tblc = "";

if ($tables[$t1])
	$tbl = $tables[$t1];
if ($tables[$t2])
	$tblc = $tables[$t2];
if ($tbl)
	$title = $tbl;
if ($tblc)
	$title .= " / $tblc";

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title><?php echo $title ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
</head>
<body>
<?php

function showdot( $c ) {
	$graphic = 1;
	$d1 = 0;
	$d2 = 0;
	#                          dot
	if ($c & 0x01) $d1 |= 1; # 1
	if ($c & 0x04) $d1 |= 2; # 2
	if ($c & 0x10) $d1 |= 4; # 3
	if ($c & 0x40) $d1 |= 8; # 7
	if ($c & 0x02) $d2 |= 1; # 4
	if ($c & 0x08) $d2 |= 2; # 5
	if ($c & 0x20) $d2 |= 4; # 6
	if ($c & 0x80) $d2 |= 8; # 8
	switch ($c & 0xC0) {
		case 0x00:
			$col = "red";
			break;
		case 0x40:
			$col = "yellow";
			break;
		case 0x80:
			$col = "blue";
			break;
		case 0xC0:
			$col = "green";
			break;
	}
	if ($graphic)
		printf("<img src=\"0x%02x.png\" alt=\"0x%02x\">", $c & 0xC0, $c & 0xC0);
	else
		echo "<table border=0 cellspacing=0 cellpadding=2 bgcolor=$col><tr><td>";
	printf("<img src=\"0%x.png\" alt=\"%x\">", $d1, $d1);
	printf("<img src=\"0%x.png\" alt=\"%x\">", $d2, $d2);
	if ($graphic)
		printf("<img src=\"0x%02x.png\" alt=\"0x%02x\">", $c & 0xC0, $c & 0xC0);
	else
		echo "</td></tr></table>";
}

function showchar($c) {
	$ctrl = array(
"NUL","SOH","STX","ETX","EOT","ENQ","ACK","BEL","BS","HT","LF","VT","FF","CR","SO","SI",
"DLE","DC1","DC2","DC3","DC4","NAC","SYN","ETB","CAN","EM","SUB","ESC","FS","GS","RS","US",
"SP");
	if ($c < 33)
		echo $ctrl[$c];
	else
		echo htmlentities(chr($c));
}

function showchar2($c) {
	if ($c < 32)
		echo "^".chr($c+64);
	else
		echo htmlentities(chr($c));
}

function canmove( $n ) {
	if ($n >= 0x01 && $n <= 0x1b)
		return false;
	if ($n >= 0x20 && $n <= 0x7e)
		return false;
	return true;
}

function showlegend() {
?><p>
<img src="0x00.png" alt="0x00"><img src="00.png" alt="00"><img src="00.png" alt="00"><img src="0x00.png" alt="0x00"> dot 78 off,
<img src="0x40.png" alt="0x40"><img src="08.png" alt="08"><img src="00.png" alt="00"><img src="0x40.png" alt="0x40"> dot 7 on 8 off,
<img src="0x80.png" alt="0x80"><img src="00.png" alt="00"><img src="08.png" alt="08"><img src="0x80.png" alt="0x80"> dot 7 off 8 on,
<img src="0xc0.png" alt="0xC0"><img src="08.png" alt="08"><img src="08.png" alt="08"><img src="0xc0.png" alt="0xc0"> dot 78 on.
</p><?php
}

if ($tbl) {
	$col = 16;
	if (!$tblc)
		$tblc = $tbl;
	echo "<table border=1 cellspacing=0 cellpadding=0 width=\"100%\">\n";
	echo "<caption>$title</caption>\n";
	echo "<tr><td>HEX<br>DEC</td>\n";
	for ($n=0;$n<$col;$n++) {
		echo "<td align=\"right\">";
		printf("%02X<br>%03d", $n, $n);
		echo "</td>\n";
	}
	echo "</tr>\n";
	$num = 0;
	$fp = fopen($tbl, "r");
	$s = fread($fp, filesize($tbl));
	fclose($fp);
	$fp = fopen($tblc, "r");
	$sc = fread($fp, filesize($tblc));
	fclose($fp);
	$diff = array();
	while ($num<256) {
		$c = ord(substr($s, $num, 1));
		$cc = ord(substr($sc, $num, 1));
		if (!($num % $col)) {
			echo "<tr valign=\"top\">\n";
			echo " <td align=\"right\">";
			printf("%02X<br>%03d", $num, $num);
			echo "</td>\n";
		}
		echo " <td align=\"center\" ".($c!=$cc?"bgcolor=\"#FFE0E0\"":"").">";
		showchar($num);
		#printf(" %02x ", $c);
		echo "<br>";
		showdot($c);
		if ($c != $cc) {
			$diff[] = $num;
			echo " ";
			showdot($cc);
			if ($num > 32) {
				echo " ";
				$n = strpos($s, $cc);
				showchar2($n);
			}
		}
		echo "</td>\n";
		if (!(++$num % $col))
			echo "</tr>\n";
	}
	echo "</table>\n";
	showlegend();
	if (count($diff))
		echo "<p>diff: ".count($diff)."</p>\n";
	reset($diff);
	$conflict = array();
	$count = 0;
	while (list(,$num) = each($diff)) {
		if (canmove($num)) {
			# 28 (GS)
			$cc = substr($sc, $num, 1);
			$n = strpos($s, $cc);
			if (canmove($n)) {
				if (!$count++)
					echo "<p>Can move: ";
				echo "$num ";
			} else {
				$conflict[] = $num;
			}
		} else {
			$conflict[] = $num;
		}
	}
	echo "</p>\n";
	if (count($conflict)) {
		echo "<p>Conflict: ";
		reset($conflict);
		while (list(,$num) = each($conflict)) {
			showchar2($num);
			echo " ";
		}
		echo "</p>\n";
	}
} else {
?>
<p>
Here is some examples of braille tables which comes with
<a href="http://www.mielke.cc/brltty/">brltty</a> .
The table <tt>text.da1252.tbl</tt> is designed by Svend Thougaard from
<a href="http://www.refsnaes.dk/">Refsnsskolen</a>. It is designed for
use with Windows code page ANSI-1252.
1252 is not very good for use with Linux as the codepage ISO-8859-1 is
the one which is used.
In <tt>text.da1252.tbl</tt> some of the control characters like ^A to ^Z
has been assigned with very unlogical dot patterns. Normally a blind
would expect a ^X to be an X with dot-8 turned on.
</p>
<p>
Hans Schou has designed <tt>text.danish.tbl</tt> which has the control
dot patterns the expected way. Other characters like !%() are assigned
as they are used with the LogText braille display.
All possible patterns are then designed as in <tt>text.da1252.tbl</tt> .
</p>
<p>
This web-application shows the dot patterns in graphics and is then only
usefull for seighted people.
Below is a list of tables in text mode:
</p>
<?php
	echo "<ul>\n";
	$d = dir("./");
	while($entry=$d->read()) {
		if (preg_match("/^text\.(.*)\.txt$/", $entry, $match))
			echo "<li><a href=\"$entry\">$match[1]</a></li>\n";
	}
	$d->close();
	echo "</ul>\n";
}

if (!$t2) {
	echo "<p>";
	if ($t1)
		echo "Compare with:\n";
	else
		echo "Select table:\n";
	reset($tables);
	while (list($name,$file) = each($tables)) {
		if ($t1) {
			if ($t1 != $name && $t2 != $name)
				echo "[<a href=\"$PHP_SELF?t1=$t1&amp;t2=$name\">$name</a>]\n";
		} else {
			if ($t2 != $name)
				echo "[<a href=\"$PHP_SELF?t1=$name\">$name</a>]\n";
		}
	}
	echo "</p>\n";
}

?>
<p><a href="http://validator.w3.org/check/referer">W3C HTML 4.01 Strict</a></p>
</body></html>
